/*********************************************************************************
 * This file is part of package Dynamic Panels.
 * 
 * Author : Variance InfoTech PVT LTD (http://www.varianceinfotech.com)
 * All rights (c) 2021 by Variance InfoTech PVT LTD
 *
 * This Version of Dynamic Panels is licensed software and may only be used in 
 * alignment with the License Agreement received with this Software.
 * This Software is copyrighted and may not be further distributed without
 * written consent of Variance InfoTech PVT LTD
 * 
 * You can contact via email at info@varianceinfotech.com
 * 
 ********************************************************************************/
if(actionName != 'EditView'){
    var formId = 'form_SubpanelQuickCreate_'+moduleName;
}else{
    var formId = 'EditView';
}//end of else

$.ajax({
        url: "index.php?entryPoint=VIDynamicPanelsConfiguration",
        type: "post",
        data: {module : moduleName},
        success: function (response) {
            if(response == "1"){
                var saveButtonOnClick;
                $('.primary').each(function () {
                    if($(this).attr('id') == 'SAVE'){
                        saveButtonOnClick = $(this).attr('onclick');
                        $(this).attr('onclick','');
                        $(this).attr('type','button');
                    }
                });//end of each
                
                var saveContinueButtonOnClick = $('.saveAndContinue').attr('onclick');
                var saveAndSendInvites = $('#save_and_send_invites_header').attr('onclick');
                $('.saveAndContinue').attr("onclick","");
                $('#save_and_send_invites_header').attr("onclick","");
                $('.saveAndContinue').attr("type","button");

                $('.primary').on('click',function(){
                    if($(this).attr('id') == 'SAVE'){
                        disabledField = [];
                        $('select:disabled').each(function () {
                            disabledField.push($(this).attr('id'));
                        });//end of each
                        
                        if(check_form('EditView')){
                            $('select:disabled').each(function () {
                                $(this).removeAttr('disabled');
                            });//end of each
                            $(this).attr('onclick',saveButtonOnClick);
                            $(this).attr('type','submit');
                            $(this).trigger("onclick");
                        }else{
                            $.each(disabledField,function(index,value){
                                $('#'+value).attr('disabled',true);
                            });//end of each
                        }//end of else
                    }//end of if
                });//end of function

                $('.saveAndContinue').on('click',function(){
                    var disabledField = [];
                    $('select:disabled').each(function () {
                        disabledField.push($(this).attr('id'));
                       $(this).removeAttr('disabled');
                    });//end of each
                    $('.saveAndContinue').attr('onclick',saveContinueButtonOnClick);
                    var valLength = $('.required.validation-message').length;
                    var formData = $('form').serialize();
                    if(valLength > 0){
                        $.each(disabledField,function(index,value){
                            $('#'+value).attr('disabled',true);
                        });//end of each
                    }else{
                        $(".saveAndContinue").trigger("onclick");
                    }//end of else
                });//end of function

                $('#save_and_send_invites_header').on('click',function(){
                    var disabledField = [];
                    $('select:disabled').each(function () {
                        disabledField.push($(this).attr('id'));
                       $(this).removeAttr('disabled');
                    });//end of each
                    $('#save_and_send_invites_header').attr('onclick',saveAndSendInvites);
                    var valLength = $('.required.validation-message').length;
                    var formData = $('form').serialize();
                    if(valLength > 0){
                        $.each(disabledField,function(index,value){
                            $('#'+value).attr('disabled',true);
                        });//end of each
                    }else{
                        $("#save_and_send_invites_header").trigger("onclick");
                    }//end of else
                });//end of function
            }//end of if
        }//end of success
});//end of ajax

//default panels and fields hide
$.ajax({
    url: "index.php?entryPoint=VIDynamicPanelsDefault",
    type: "post",
    data: {module : moduleName,
          actionName : actionName},
    dataType : "JSON",
    success: function (response) {
        var autoPopulateFieldArray = response['autoPopulateFieldArray'];

        //defautl field hide
        var defaultFieldsHide = response['defaultFieldsHide'];
        dynamicPanelsFieldShowHide(defaultFieldsHide,actionName,formId,'hide');
        
        //default tabs hide
        var viewTabsHide = response['viewTabsHide'];
        viewTabsHide = jQuery.parseJSON(viewTabsHide);
        dynamicPanelsTabsHide(viewTabsHide);
        

        //default panels hide
        var viewPanelsHide = response['viewPanelsHide'];
        viewPanelsHide = jQuery.parseJSON(viewPanelsHide);
        dynamicPanelsHide(viewPanelsHide);
        
        $('ul.nav-tabs > li > a[data-toggle=tab]').each(function(){
            var panelName = $.trim($(this).text());
            var tabId = $(this).attr("id");
            $('body').on('click','ul.nav-tabs > li > a[id='+tabId+']',function(){
                var arr = tabId.substr(-1);
                $('div .panel-heading').each(function(){
                    var panels = $.trim($(this).closest('div').text());
                    var tabPanelId = $.trim($(this).parent('div').attr('class').substr(-1));
                    if(arr == tabPanelId){
                        if(jQuery.inArray(panels,viewPanelsHide) != '-1'){
                            $(this).closest('div').parent().hide();
                        }//end of if 
                    }//end of if
                });//end of each

                if(jQuery.inArray(panelName,viewPanelsHide) != '-1'){
                    $('ul.nav-tabs > li > a[id='+tabId+']').parent().hide();
                    var arr = tabId.substr(-1);
                    $('div[id=tab-content-'+arr+']').hide();
                }//end of if

                if(jQuery.inArray(panelName,viewTabsHide) != '-1'){
                    $('ul.nav-tabs > li > a[id='+tabId+']').parent().hide();
                    var arr = tabId.substr(-1);
                    $('div[id=tab-content-'+arr+']').hide();
                }//end of if

                $('div .panel-heading').each(function(){
                    var panels = $.trim($(this).closest('div').text());
                    var tabPanelId = $.trim($(this).parent('div').attr('class').substr(-1));
                    if(arr == tabPanelId){
                        if(jQuery.inArray(panels,viewTabsHide) != '-1'){
                                $(this).closest('div').parent().hide();
                        }//end of if
                    }           
                });//end of each
            });
        });

        //remove default fields required validation which is hide
        var removeFromValidateDefaultFields = response['removeFromValidateDefaultFields'];
        removeFromValidateDynamicPanelsFields(removeFromValidateDefaultFields,formId);
        
        //remove default panels required fields validation which is hide 
        var removeFromValidatePanelFields = response['removeFromValidatePanelFields'];
        removeFromValidatePanelFields = jQuery.parseJSON(removeFromValidatePanelFields);
        removeFromValidateDynamicPanelsFields(removeFromValidatePanelFields,formId);
        
        //autopopulate field
        var autoPopulateFieldArray = response['autoPopulateFieldArray'];
        
        autoPopulateFieldValue(autoPopulateFieldArray,formId);

        //readonly field
        var readOnlyFieldArray = response['defaultReadonlyFieldsArray'];
        readOnlyFields(readOnlyFieldArray,formId);

        //mandatory field
        var mandatoryFieldArray = response['defaultMandatoryFieldsArray'];
        mandatoryFieldsArray(mandatoryFieldArray,formId);
    }//end of success
});//end of ajax

$.ajax({
    url: "index.php?entryPoint=VIDynamicPanelsModuleFieldLabel",
    type: "post",
    data: {module : moduleName,
          actionName : actionName},
    dataType : "JSON",
    success: function (response) {
        var fieldLabel = response['fieldLabel'];
        $.each(fieldLabel, function (index, value) {
            YAHOO.util.Event.onDOMReady(function(){
                fieldType = $("#"+formId+" div[field='"+value+"']").attr('type'); //field type
                
                if(value == 'direction'){
                    fieldType = 'enum';
                }//end of if

                if(fieldType == 'enum'){
                    val = "select[name="+value+"]";
                }else if(fieldType == 'multienum'){
                    val = "select[name='"+value+"[]']";
                }else if(fieldType == 'text'){
                    val = "textarea[name="+value+"]";
                }else {
                    val = "input[name="+value+"]";
                }//end of else

                YAHOO.util.Event.addListener(YAHOO.util.Selector.query(val), 'change', function(){
                    var formData = $("#"+formId).serialize(); //formdata
                    if($("#"+formId+" div[field='"+value+"']").attr('type') == 'relate'){
                        value = $("#"+formId+" div[field='"+value+"']").after().find("input[type='hidden']").attr('name');  
                    }//end of if

                    fieldType = $("#"+formId+" div[field='"+value+"']").attr('type'); //field type

                    if(fieldType == 'bool'){
                        var element = $("#"+formId+" div[field='"+value+"']").after().find("input[type='checkbox']");
                        
                        if(element.is(":checked")){
                            fieldValue = '1';
                        }else{
                            fieldValue = '0';
                        }//end of else

                        $("#"+formId+" div[field='"+value+"']").after().find("input[type='hidden']").val(fieldValue);
                    }else{
                        fieldValue = $('#'+formId+' #'+value).val(); //field value
                    }//end of else

                    $.ajax({
                        url: "index.php?entryPoint=VIDynamicPanelsCheckCondition",
                        type: "post",
                        data: {module : moduleName,
                              fieldName : value,
                              fieldValue : fieldValue,
                              fieldType : fieldType,
                              formData : formData,
                              actionName : actionName,
                              recordId : recordId},
                        dataType: "JSON",
                        success: function(result) {
                            $.each(result,function(index,data){
                                if(data['success'] == 'true'){
                                    var editViewTabsHide = data['editViewTabsHide'];
                                    var editViewPanelsHide = data['editViewPanelsHide'];
                                    var editViewTabsShow = data['editViewTabsShow'];
                                    var editViewPanelsShow = data['editViewPanelsShow'];
                                    var removeFromValidatePanelFields = data['removeFromValidatePanelFields'];
                                    var fieldsShow = data['fieldsShowArray'];
                                    var fieldsHide = data['fieldsHideArray'];
                                    var addToValidatePanelFieldsShow = data['addToValidatePanelFieldsShow'];
                                    var removeFromValidateFieldsHide = data['removeFromValidateFieldsHide'];
                                    var addToValidateFieldsShow = data['addToValidateFieldsShow'];
                                    var fieldsMandatoryArray = data['fieldsMandatoryArray'];
                                    var fieldsReadOnlyArray = data['fieldsReadOnlyArray'];
                                    var autoPopulateField = data['autoPopulateFieldArray'];

                                    //tabs Hide
                                    dynamicPanelsTabsHide(editViewTabsHide);
                                    
                                    //panels Hide
                                    dynamicPanelsHide(editViewPanelsHide);
                                    
                                    dynamicPanelsTabPanelsHide(editViewPanelsHide,editViewTabsHide);
                                    
                                    //tabs Show
                                    dynamicPanelsTabsShow(editViewTabsShow);

                                    //panels Show
                                    dynamicPanelsShow(editViewPanelsShow);

                                    dynamicPanelsTabPanelsShow(editViewPanelsShow,editViewTabsShow);
                                    
                                    //remove panels required fields validation which is hide
                                    removeFromValidateDynamicPanelsFields(removeFromValidatePanelFields,formId); 
                                    
                                    //fields show
                                    dynamicPanelsFieldShowHide(fieldsShow,actionName,formId,'show');
                                    
                                    //fields hide
                                    dynamicPanelsFieldShowHide(fieldsHide,actionName,formId,'hide');
                                    
                                    addToValidateDynamicPanelsFields(addToValidatePanelFieldsShow,formId);
                                    
                                    //remove fields required validation which is hide
                                    removeFromValidateDynamicPanelsFields(removeFromValidateFieldsHide,formId); 
                                    
                                    //add to validate fields which is show
                                    addToValidateDynamicPanelsFields(addToValidateFieldsShow,formId);
                                    
                                    //field mandatory
                                    mandatoryFieldsArray(fieldsMandatoryArray,formId);
                                    
                                    //field readonly
                                    readOnlyFields(fieldsReadOnlyArray,formId);

                                    //field autopopulate 
                                    autoPopulateFieldValue(autoPopulateField,formId);
                                    
                                    //field color
                                    var fieldColorArray = data['fieldColorrArray'];
                                    dynamicPanelsFieldColor(fieldColorArray,formId,'');
                                    
                                }else{
                                    var displayAllFields = data['displayAllFields'];
                                    dynamicPanelsFieldShowHide(displayAllFields,actionName,formId,'show');
                                    
                                    //tabs Hide
                                    var defaulteditViewTabsHide = data['defaulteditViewTabsHide'];
                                    dynamicPanelsTabsHide(defaulteditViewTabsHide);
                                    
                                    //panels Hide
                                    var defaulteditViewPanelsHide = data['defaulteditViewPanelsHide'];
                                    dynamicPanelsHide(defaulteditViewPanelsHide);
                                    
                                    dynamicPanelsTabPanelsHide(defaulteditViewPanelsHide,defaulteditViewTabsHide);
                                   
                                    //tabs Show
                                    var defaulteditViewTabsShow = data['defaulteditViewTabsShow'];
                                    dynamicPanelsTabsShow(defaulteditViewTabsShow);
                                    
                                    //panels Show
                                    var defaulteditViewPanelsShow = data['defaulteditViewPanelsShow'];
                                    dynamicPanelsShow(defaulteditViewPanelsShow);
                                    
                                    var fieldsNonMandatoryArray = data['fieldsNonMandatoryArray'];
                                    $.each(fieldsNonMandatoryArray, function (index, value) {
                                        var find = "_address_";
                                        if(value.field.indexOf(find) != -1){
                                            if(value.field != ''){
                                                $('#'+formId+' #'+value.field).closest('td').prev('td').find('span').remove();
                                                $("#"+formId+" div[field='"+value.field+"']").prev().find("span").remove();
                                            }//end of if
                                        }else{
                                            if(value != ''){
                                                $("#"+formId+" div[field='"+value.field+"']").prev().find("span").remove();
                                            }//end of if
                                        }//end of else
                                        removeFromValidate(formId,value.field);
                                    });//end of each

                                    var removeFromValidatePanelHideFields = data['removeFromValidatePanelHideFields'];
                                    removeFromValidateDynamicPanelsFields(removeFromValidatePanelHideFields,formId);
                                    
                                    var addToValidateFieldsShow = data['addToValidateFieldsShow'];
                                    addToValidateDynamicPanelsFields(addToValidateFieldsShow,formId);
                                    
                                    var defaultFieldsHideArray = data['defaultFieldsHideArray'];
                                    dynamicPanelsFieldShowHide(defaultFieldsHideArray,actionName,formId,'hide');
                                    
                                    var defaultFieldsShowArray = data['defaultFieldsShowArray'];
                                    dynamicPanelsFieldShowHide(defaultFieldsShowArray,actionName,formId,'show');
                                    
                                    var removeFromValidateDefaultFields = data['removeFromValidateDefaultFields'];
                                    removeFromValidateDynamicPanelsFields(removeFromValidateDefaultFields,formId);
                                    
                                    var removeReadOnly = data['removeReadOnly'];
                                    $.each(removeReadOnly, function (index, value) {
                                        if(value.field != ''){
                                            if(value.type == 'enum'  || value.type == 'bool' || value.type == "dynamicenum" || value.type == "radioenum" || value.type == 'multienum'){
                                                $("#"+formId+" #"+value.field).removeAttr("disabled", true);
                                            }else if(value.type == 'date'){
                                                $("#"+formId+" #"+value.field).removeAttr("readonly", true);
                                                $("#"+formId+" #"+value.field+'_trigger').removeAttr("disabled", true);
                                            }else if(value.type == 'datetimecombo' || value.type == 'datetime'){
                                                $("#"+formId+" #"+value.field+"_date").removeAttr("readonly", true);
                                                $("#"+formId+" #"+value.field+'_trigger').removeAttr("disabled", true);
                                                $("#"+formId+" #"+value.field+'_hours').removeAttr("disabled", true);
                                                $("#"+formId+" #"+value.field+'_minutes').removeAttr("disabled", true);
                                            }else if(value.type == 'relate'){
                                                $("#"+formId+" #"+value.field).removeAttr("readonly", true);
                                                $("#"+formId+" #btn_"+value.field).removeAttr("disabled", true);
                                                $("#"+formId+" #btn_clr_"+value.field).removeAttr("disabled", true);
                                            }else{
                                                if(value.field == 'currency_id'){
                                                    $("#"+formId+" #"+value.field+'_select').removeAttr("disabled", true);
                                                }else if(value.field == 'revision'){
                                                    $("#"+formId+" input[name="+value.field+"]").removeAttr("readonly", true);
                                                }else if(value.field == 'account_name' && moduleName == 'Leads'){
                                                    $("#"+formId+" input[name="+value.field+"]").removeAttr("readonly", true);
                                                }else{
                                                    $("#"+formId+" #"+value.field).removeAttr("readonly", true);
                                                }//end of else
                                            }//end of else
                                        }//end of if
                                    });//end of each

                                    var removeautoPopulateFieldValue = data['removeautoPopulateFieldValue'];
                                    $.each(removeautoPopulateFieldValue, function (index, value) {
                                        if(value.type == 'relate'){
                                            if(value.autoPopulateFieldName != ''){
                                                var currentVal = $('#'+formId+' #'+value.autoPopulateFieldName).val();
                                                var currentRelateFieldVal = $('#'+formId+' #'+value.relateFieldName).val();
                                                var autoPopulateVal = value.autopopulateFieldValue;
                                                var autoPopulateRelateFieldVal = value.relateFieldValue;
                                                if(currentVal == autoPopulateVal){
                                                    $('#'+formId+' #'+value.autoPopulateFieldName).val('');
                                                }//end of if

                                                if(currentRelateFieldVal == autoPopulateRelateFieldVal){
                                                    $('#'+formId+' #'+value.relateFieldName).val('');    
                                                }//end of if
                                            }//end of if
                                        }else if(value.type == 'bool'){
                                            if(value.autoPopulateFieldName != ''){
                                                $('#'+formId+' #'+value.autoPopulateFieldName).prop('checked',false);
                                                var elementId = $('#'+formId+' #'+value.autoPopulateFieldName);
                                                if( elementId.change != null ){
                                                    $(elementId).trigger('change');           
                                                }//end of if
                                            }//end of if

                                        }else if(value.type == 'datetimecombo' || value.type == 'datetime'){
                                            if(value.autoPopulateFieldName != ''){
                                                dateValue = $('#'+formId+' #'+value.autoPopulateFieldName).val();

                                                var dbdate = dateValue.split(' ')[0];
                                                var date = new Date(dateValue);
                                                if(date != 'Invalid Date'){
                                                    var hours = date.getHours();
                                                    if(hours < 10){
                                                        hours = '0' + hours;
                                                    }
                                                    var minutes = date.getMinutes();
                                                    if(minutes < 10){
                                                        minutes = '0' + minutes;
                                                    }
                                                    $('#'+formId+' #'+value.autoPopulateFieldName+'_date').val(dbdate);
                                                    $('#'+formId+' #'+value.autoPopulateFieldName+'_hours').val(hours);
                                                    $('#'+formId+' #'+value.autoPopulateFieldName+'_minutes').val(minutes);
                                                }//end of if
                                            }//end of if
                                        }else if(value.type == 'date'){
                                            $('#'+formId+' #'+value.autoPopulateFieldName).val('');
                                        }else{
                                            var currentVal = $('#'+formId+' #'+value.autoPopulateFieldName).val();
                                            var autoPopulateVal = value.autopopulateFieldValue;
                                            if(currentVal == autoPopulateVal){
                                                if(value.autoPopulateFieldName != ''){
                                                    $("#"+formId+" #"+value.autoPopulateFieldName).val('');
                                                }//end of if
                                            }//end of if
                                        }//end of else   
                                    });//end of each

                                    //field color
                                    var fieldColorArray = data['fieldColorrArray'];
                                    dynamicPanelsFieldColor(fieldColorArray,formId,'remove');
                                }//end of else 
                            });//end of each 
                        }//end of success        
                    });//end of ajax
                });//end of function
            });//end of function
        });//end of function
    }//end of success
});//end of ajax

if(recordId != ''){
    var formData = $("#EditView").serialize();
    $.ajax({
        url: "index.php?entryPoint=VIDynamicPanelsCheckCondition",
        type: "post",
        data: {module : moduleName,
              recordId : recordId,
              formData : formData,
              actionName : actionName,
              onPageLoad : 1},
        dataType : "JSON",
        success: function(result) {
            $.each(result,function(index,data){
                if(data['success'] == 'true'){
                    var editViewTabsHide = data['editViewTabsHide'];
                    var editViewPanelsHide = data['editViewPanelsHide'];
                    var editViewTabsShow = data['editViewTabsShow'];
                    var editViewPanelsShow = data['editViewPanelsShow'];

                    //tabs Hide
                    dynamicPanelsTabsHide(editViewTabsHide);
                    
                    //panels Hide
                    dynamicPanelsHide(editViewPanelsHide);
                    
                    dynamicPanelsTabPanelsHide(editViewPanelsHide,editViewTabsHide);

                    //tabs Show
                    dynamicPanelsTabsShow(editViewTabsShow);
                    
                    //panels Show
                    dynamicPanelsShow(editViewPanelsShow);

                    dynamicPanelsTabPanelsShow(editViewPanelsShow,editViewTabsShow);

                    //remove panels required fields validation which is hide 
                    var removeFromValidatePanelFields = data['removeFromValidatePanelFields'];
                    removeFromValidateDynamicPanelsFields(removeFromValidatePanelFields,formId);
                    
                    //fields hide
                    var fieldsHide = data['fieldsHideArray'];
                    dynamicPanelsFieldShowHide(fieldsHide,actionName,formId,'hide');
                    
                    //fields show
                    var fieldsShow = data['fieldsShowArray'];
                    dynamicPanelsFieldShowHide(fieldsShow,actionName,formId,'show');
                    
                    //remove fields required validation which is hide
                    var removeFromValidateFieldsHide = data['removeFromValidateFieldsHide'];
                    removeFromValidateDynamicPanelsFields(removeFromValidateFieldsHide,formId);
                    
                    //add to validate fields which is show
                    var addToValidateFieldsShow = data['addToValidateFieldsShow'];
                    addToValidateDynamicPanelsFields(addToValidateFieldsShow,formId);
                    
                    //add to validate panels fields which is show
                    var addToValidatePanelFieldsShow = data['addToValidatePanelFieldsShow'];
                    addToValidateDynamicPanelsFields(addToValidatePanelFieldsShow,formId);
                    
                    //field mandatory
                    var fieldsMandatoryArray = data['fieldsMandatoryArray'];
                    mandatoryFieldsArray(fieldsMandatoryArray,formId);

                    //field readonly
                    var fieldsReadOnlyArray = data['fieldsReadOnlyArray'];
                    readOnlyFields(fieldsReadOnlyArray,formId);
                    
                    //field autopopulate 
                    var autoPopulateField = data['autoPopulateFieldArray'];
                    autoPopulateFieldValue(autoPopulateField,formId);
                    
                    //field color
                    var fieldColorArray = data['fieldColorrArray'];
                    dynamicPanelsFieldColor(fieldColorArray,formId,'');
                }//end of if
            });//end of each
        }//end of success        
    });//end of ajax
}//end of if

function autoPopulateFieldValue(autoPopulateFieldArray,formId){
    if(autoPopulateFieldArray != ''){
        $.each(autoPopulateFieldArray, function (index, value) {
            if(value.type == 'relate'){
                $("#"+value.relateFieldName).blur();
                $('#'+formId+' #'+value.autoPopulateFieldName).val(value.autopopulateFieldValue);
                $('#'+formId+' #'+value.relateFieldName).val(value.relateFieldValue);
            }else if(value.type == 'bool'){
                if(value.autopopulateFieldValue == '1'){
                    $('#'+formId+' #'+value.autoPopulateFieldName).prop('checked',true);
                    var elementId = $('#'+formId+' #'+value.autoPopulateFieldName);
                    if( elementId.change != null ){
                        $(elementId).trigger('change');           
                    }//end of if
                }else{
                    $('#'+formId+' #'+value.autoPopulateFieldName).prop('checked',false);
                    var elementId = $('#'+formId+' #'+value.autoPopulateFieldName);
                    if( elementId.change != null ){
                        $(elementId).trigger('change');           
                    }//end of if
                }//end of else
            }else if(value.type == 'datetimecombo' || value.type == 'datetime'){
                if(value.autopopulateFieldValue != null){
                    var date = new Date(value.autopopulateFieldValue);
                    if(date != 'Invalid Date'){
                        var dbdate = value.autopopulateFieldValue.split(' ')[0];
                        var hours = date.getHours();
                        if(hours < 10){
                            hours = '0' + hours;
                        }//end of if
                        var minutes = date.getMinutes();
                        if(minutes < 10){
                            minutes = '0' + minutes;
                        }//end of if

                        $('#'+formId+' #'+value.autoPopulateFieldName+'_date').val(dbdate);
                        $('#'+formId+' #'+value.autoPopulateFieldName+'_hours').val(hours);
                        $('#'+formId+' #'+value.autoPopulateFieldName+'_minutes').val(minutes);
                    }//end of if
                }//end of if
            }else if(value.type == 'date'){
                if(value.autopopulateFieldValue != null){
                    var date = new Date(value.autopopulateFieldValue);
                    if(date != 'Invalid Date'){
                        var datetime = value.autopopulateFieldValue.split(' ')[0];
                        $('#'+formId+' #'+value.autoPopulateFieldName).val(datetime);
                    }//end of if
                }//end of if
            }else if(value.type == 'multienum'){
                $('#'+formId+ ' select[id="'+value.autoPopulateFieldName+'"]').val('');
                $.each(value.autopopulateFieldValue,function(i,v){
                    $('#'+formId+ ' select[id="'+value.autoPopulateFieldName+'"]').find("option[value='']").prop('selected',false);
                    $('#'+formId+ ' select[id="'+value.autoPopulateFieldName+'"]').find("option[value='"+v+"']").prop("selected",true);
                });
            }else{
                if(value.autoPopulateFieldName != ''){
                    $('#'+formId+' #'+value.autoPopulateFieldName).val(value.autopopulateFieldValue);
                    $('#'+formId+' input[name='+value.autoPopulateFieldName+']').val(value.autopopulateFieldValue);    
                }//end of if
            }//end of else
        });
    }//end of if
}//end of function

function readOnlyFields(readonlyFieldsArray,formId){
    $.each(readonlyFieldsArray, function (index, value) {
        if(value.field != ''){
            if(value.type == 'enum' || value.type == 'bool' || value.type == "dynamicenum" || value.type == "radioenum" || value.type == 'multienum'){
                $("#"+formId+" #"+value.field).attr("disabled", true);
            }else if(value.type == 'date'){
                $("#"+formId+" #"+value.field).attr("readonly", true);
                $("#"+formId+" #"+value.field+"_trigger").attr("disabled", true);
            }else if(value.type == 'datetimecombo' || value.type == 'datetime'){
                $("#"+formId+" #"+value.field+"_date").attr("readonly", true);
                $("#"+formId+" #"+value.field+"_trigger").attr("disabled", true);
                $("#"+formId+" #"+value.field+"_hours").attr("disabled", true);
                $("#"+formId+" #"+value.field+"_minutes").attr("disabled", true);
            }else if(value.type == 'relate'){
                $("#"+formId+" #"+value.field).attr("readonly", true);
                $("#"+formId+" #btn_"+value.field).attr("disabled", true);
                $("#"+formId+" #btn_clr_"+value.field).attr("disabled", true);
            }else{
                if(value.field == 'currency_id'){
                    $("#"+formId+" #"+value.field+'_select').attr("disabled", true);
                }else if(value.field == 'revision'){
                    $("#"+formId+" input[name="+value.field+"]").attr("readonly", true);
                }else if(value.field == 'account_name' && moduleName == 'Leads'){
                    $("#"+formId+" input[name="+value.field+"]").attr("readonly", true);
                }else{
                    $("#"+formId+" #"+value.field).attr("readonly", true);    
                }
            }//end of else
        }//end of if
    });//end of function
}//end of function

function mandatoryFieldsArray(fieldsMandatoryArray,formId){
    $.each(fieldsMandatoryArray,function(index,value){
        var find = "_address_";
        if(value.field.indexOf(find) != -1){
            var requiredClass = $('#'+value.field).closest('td').prev('td').find('span').attr('class');
            if(requiredClass != 'required'){
                $('#'+value.field).closest('td').prev('td').append('<span class="required">*</span>');
            }//end of if
            var requiredClass = $("div[field='"+value.field+"']").prev().find('span').attr('class');
            if(requiredClass != 'required'){
                $("div[field='"+value.field+"']").prev().append('<span class="required">*</span>');    
            }//end of if
        }else{
            var requiredClass = $("div[field='"+value.field+"']").prev().find('span').attr('class');
            if(requiredClass != 'required'){
                $("div[field='"+value.field+"']").prev().append('<span class="required">*</span>');    
            }//end of if
        }//end of else
        addToValidate(formId,''+value.field+'','',true,'Field is required.');
    });//end of function
}//end of function

function dynamicPanelsTabsHide(viewTabsHide){
    $('ul.nav-tabs > li > a[data-toggle=tab]').each(function(){
        var panelName = $.trim($(this).text());
        var tabId = $(this).attr("id");
        if(jQuery.inArray(panelName,viewTabsHide) != '-1'){
            $('ul.nav-tabs > li > a[id='+tabId+']').parent().hide();
            var arr = tabId.substr(-1);
            $('div[id=tab-content-'+arr+']').hide();
        }//end of if
    });//end of each

    $('div .panel-heading').each(function(){
        var panels = $.trim($(this).closest('div').text());
        if(jQuery.inArray(panels,viewTabsHide) != '-1'){
                $(this).closest('div').parent().hide();
        }//end of if 
    });//end of each
}//end of function

function dynamicPanelsHide(viewPanelsHide){
    $('div .panel-heading').each(function(){
        var panels = $.trim($(this).closest('div').text());
        if(jQuery.inArray(panels,viewPanelsHide) != '-1'){
                $(this).closest('div').parent().hide();
        }//end of if
    });//end of each

    $('ul.nav-tabs > li > a[data-toggle=tab]').each(function(){
        var panelName = $.trim($(this).text());
        var tabId = $(this).attr("id");
        if(jQuery.inArray(panelName,viewPanelsHide) != '-1'){
            $('ul.nav-tabs > li > a[id='+tabId+']').parent().hide();
            var arr = tabId.substr(-1);
            $('div[id=tab-content-'+arr+']').hide();
        }//end of if
    });//end of each
}//end of function

function dynamicPanelsTabPanelsHide(editViewPanelsHide,editViewTabsHide){
    $('ul.nav-tabs > li > a[data-toggle=tab]').each(function(){
        var panelName = $.trim($(this).text());
        var tabId = $(this).attr("id");
        $('body').on('click','ul.nav-tabs > li > a[id='+tabId+']',function(){
            
            $('div .panel-heading').each(function(){
                var panels = $.trim($(this).closest('div').text());
                if(jQuery.inArray(panels,editViewPanelsHide) != '-1'){
                        $(this).closest('div').parent().hide();
                }//end of if 
            });//end of each

            if(jQuery.inArray(panelName,editViewPanelsHide) != '-1'){
                $('ul.nav-tabs > li > a[id='+tabId+']').parent().hide();
                var arr = tabId.substr(-1);
                $('div[id=tab-content-'+arr+']').hide();
            }//end of if

            if(jQuery.inArray(panelName,editViewTabsHide) != '-1'){
                $('ul.nav-tabs > li > a[id='+tabId+']').parent().hide();
                var arr = tabId.substr(-1);
                $('div[id=tab-content-'+arr+']').hide();
            }//end of if

            $('div .panel-heading').each(function(){
                var panels = $.trim($(this).closest('div').text());
                if(jQuery.inArray(panels,editViewTabsHide) != '-1'){
                        $(this).closest('div').parent().hide();
                }//end of if 
            });//end of each
        });//end of each
    });//end of each
}//end of function

function dynamicPanelsTabsShow(editViewTabsShow){
    $('ul.nav-tabs > li > a[data-toggle=tab]').each(function(){
        var panelName = $.trim($(this).text());
        var tabId = $(this).attr("id");
        if(jQuery.inArray(panelName,editViewTabsShow) != '-1'){
            $('ul.nav-tabs > li > a[id='+tabId+']').parent().show();
            var arr = tabId.substr(-1);
            var currentTab = $('li.active > a[data-toggle=tab]').attr('id');
            if(currentTab != '' && currentTab != undefined){
                var arr = currentTab.substr(-1);
                $('div[id=tab-content-'+arr+']').show();
            }else{
                var arr = '';
            }
        }//end of if
    });//end of function
    $('div .panel-heading').each(function(){
        var panels = $.trim($(this).closest('div').text());
        var tabPanelId = $.trim($(this).closest('div').attr('class').substr(-1));
        var currentTab = $('li.active > a[data-toggle=tab]').attr('id');
        if(currentTab != '' && currentTab != undefined){
            var arr = currentTab.substr(-1);
        }else{
            var arr = '';
        }
        if(jQuery.inArray(panels,editViewTabsShow) != '-1'){
            if(arr == '' || arr == undefined){
                $(this).closest('div').parent().show();
            }else{
                if(arr == tabPanelId){
                    $(this).closest('div').parent().show();
                }
            }
        }//end of if
    });//end of function
}//end of function

function dynamicPanelsFieldShowHide(fields,actionName,formId,type){
    $.each(fields, function (index, value) {
        if(value != '(empty)' && value != '(filler)'){
            var find = "_address_";
            if(value.indexOf(find) != -1){
                if(actionName != 'EditView'){
                    if(value != ''){
                        if(type == 'hide'){
                            $('#'+formId+' #'+value).closest('tr').hide();
                        }else{
                            $('#'+formId+' #'+value).closest('tr').show();
                        }//end of else
                    }//end of if
                }else{
                    if(type == 'hide'){
                        $('#'+value).closest('tr').hide();
                    }else{
                        $('#'+value).closest('tr').show();
                    }//end of else
                }//end of else
            }else{
                if(actionName != 'EditView'){
                    if(value != ''){
                        if(type == 'hide'){
                            $("#"+formId+" div[field='"+value+"']").parent().hide();
                        }else{
                            $("#"+formId+" div[field='"+value+"']").parent().show();
                        }//end of else
                    }//end of if
                }else{
                    if(type == 'hide'){
                        $("div[field='"+value+"']").parent().hide();
                    }else{
                         $("div[field='"+value+"']").parent().show();
                    }//end of else
                }//end of else    
            }//end of else
        }//end of if
    });//end of each
}//end of function

function removeFromValidateDynamicPanelsFields(fields,formId){
    $.each(fields, function (index, value) {
        removeFromValidate(formId,value);
    });//end of function
}//end of function

function dynamicPanelsFieldColor(fieldColorArray,formId,type){
    $.each(fieldColorArray, function(index,value){
        if(value.type == 'datetimecombo'){
            if(type == 'remove'){
                $('#'+formId+' #'+value.fieldName+'_date').css('background','');
                $('#'+formId+' #'+value.fieldName+'_hours').css('background','');
                $('#'+formId+' #'+value.fieldName+'_minutes').css('background','');
            }else{
                $('#'+formId+' #'+value.fieldName+'_date').css('background','#'+value.fieldColor);
                $('#'+formId+' #'+value.fieldName+'_hours').css('background','#'+value.fieldColor);
                $('#'+formId+' #'+value.fieldName+'_minutes').css('background','#'+value.fieldColor);
            }//end of else
        }else{
            if(value.fieldName == 'revision'){
                if(type == 'remove'){
                    $('#'+formId+' input[name=revision]').css('background','');
                }else{
                    $('#'+formId+' input[name=revision]').css('background','#'+value.fieldColor);
                }//end of else
            }else if(value.fieldName == 'currency_id'){
                if(type == 'remove'){
                    $('#'+formId+' #currency_id_select').css('background','');
                }else{
                    $('#'+formId+' #currency_id_select').css('background','#'+value.fieldColor);
                }//end of else
            }else{
                if(value.fieldName != ''){
                    if(type == 'remove'){
                        $('#'+formId+' #'+value.fieldName).css('background','');
                    }else{
                        $('#'+formId+' #'+value.fieldName).css('background','#'+value.fieldColor);
                    }//end of else
                }//end of if
            }//end of else
        }//end of else
    });//end of each 
}//end of function

function addToValidateDynamicPanelsFields(fields,formId){
    $.each(fields,function(index,value){
        if(value.type == 'file'){
            addToValidate(formId,''+value.field+'_file','',true,'Field is required.');
        }else{
            addToValidate(formId,''+value.field+'','',true,'Field is required.');
        }//end of else
    });//end of function
}//end of function

function dynamicPanelsShow(editViewPanelsShow){
    $('div .panel-heading').each(function(){
        var panels = $.trim($(this).closest('div').text());
        var tabPanelId = $.trim($(this).closest('div').attr('class').substr(-1));
        var currentTab = $('li.active > a[data-toggle=tab]').attr('id');
        if(currentTab != '' && currentTab != undefined){
            var arr = currentTab.substr(-1);
        }else{
            var arr = '';
        }//end of else

        if(jQuery.inArray(panels,editViewPanelsShow) != '-1'){
            if(arr == '' || arr == undefined){
                $(this).closest('div').parent().show();
            }else{
                if(arr == tabPanelId){
                    $(this).closest('div').parent().show();
                }//end of if
            }//end of else
        }//end of if
    });//end of function

    $('ul.nav-tabs > li > a[data-toggle=tab]').each(function(){
        var panelName = $.trim($(this).text());
        var tabId = $(this).attr("id");
        if(jQuery.inArray(panelName,editViewPanelsShow) != '-1'){
            $('ul.nav-tabs > li > a[id='+tabId+']').parent().show();
            var arr = tabId.substr(-1);;
            $('div[id=tab-content-'+arr+']').show();
        }//end of if
    });//end of function
}//end of function

function dynamicPanelsTabPanelsShow(editViewPanelsShow,editViewTabsShow){
    $('ul.nav-tabs > li > a[data-toggle=tab]').each(function(){
        var panelName = $.trim($(this).text());
        var tabId = $(this).attr("id");
        $('body').on('click','ul.nav-tabs > li > a[id='+tabId+']',function(){
            var arr = tabId.substr(-1);
            $('div .panel-heading').each(function(){
                var panels = $.trim($(this).closest('div').text());
                var tabPanelId = $.trim($(this).parent('div').attr('class').substr(-1));
                if(arr == tabPanelId){
                    if(jQuery.inArray(panels,editViewPanelsShow) != '-1'){
                        $(this).closest('div').parent().show();
                    }//end of if 
                }//end of if
            });//end of each

            if(jQuery.inArray(panelName,editViewPanelsShow) != '-1'){
                $('ul.nav-tabs > li > a[id='+tabId+']').parent().show();
                var arr = tabId.substr(-1);
                $('div[id=tab-content-'+arr+']').show();
            }//end of if

            if(jQuery.inArray(panelName,editViewTabsShow) != '-1'){
                $('ul.nav-tabs > li > a[id='+tabId+']').parent().show();
                var arr = tabId.substr(-1);
                $('div[id=tab-content-'+arr+']').show();
            }//end of if

            $('div .panel-heading').each(function(){
                var panels = $.trim($(this).closest('div').text());
                var tabPanelId = $.trim($(this).parent('div').attr('class').substr(-1));
                if(arr == tabPanelId){
                    if(jQuery.inArray(panels,editViewTabsShow) != '-1'){
                            $(this).closest('div').parent().show();
                    }//end of if 
                }//end of if
            });//end of each
        });
    });
}//end of function